# README #

Компонент **iplogic:catalog.sort** предназначен для управления сортировкой списков пользователем на страницах сайта. Результаты выбора хранятся в сессии пользователя или cookie файлах.

### Подключение ###

Создайте на сайте директорию `\local\components\iplogic`. Скопируйте в нее скачанную директорию компонента iplogic:catalog.sort.

Перед вызовом компонента вывода списка элементов (например, catalog.section, news.list и т.п.) вставьте вызов компонента. Код для подключения:

```
<?$APPLICATION->IncludeComponent(
	"iplogic:catalog.sort",
	"",
	Array(
		"SAVE_IN"  => "С",
		"COOKIE_EXPIRES" => "10",
		"SUFFIX" => "jp6Yh5F48",
		"CACHE_TIME" => "36000"
		"CACHE_TYPE" => "N",
		"COMPONENT_TEMPLATE" => ".default",
		"ELEMENT_SORT_FIELD" => "SORT",
		"ELEMENT_SORT_ORDER" => "DESC",
		"SORTING" => "[{\"TYPE\":\"DEFAULT\",\"NAME\":\"По умолчанию\"},{\"TYPE\":\"POPULARITY\",\"NAME\":\"По популярности\"},{\"TYPE\":\"PRICE_ASC\",\"NAME\":\"Цена по возрастанию\"},{\"TYPE\":\"PRICE_DESC\",\"NAME\":\"Цена по убыванию\"},{\"TYPE\":\"NAME_ASC\",\"NAME\":\"Название по возрастанию\"},{\"TYPE\":\"NAME_DESC\",\"NAME\":\"Название по убыванию\"}]",
	),
	false
);?>
```

В коде вызова компонента списка

```
<?$intSectionID = $APPLICATION->IncludeComponent(
	"bitrix:catalog.section",
	"",
	array(
		...
		"ELEMENT_SORT_FIELD" => $GLOBALS['IPL_SORT']["IPL_SORT_jp6Yh5F48_SORT"],
		"ELEMENT_SORT_ORDER" => $GLOBALS['IPL_SORT']["IPL_SORT_jp6Yh5F48_ORDER"],
		"ELEMENT_SORT_FIELD2" => $arParams["ELEMENT_SORT_FIELD2"],
		"ELEMENT_SORT_ORDER2" => $arParams["ELEMENT_SORT_ORDER2"],
		...
	),
	$component
);?>
```
Здесь jp6Yh5F48 - свойства SUFFIX компонента сортировки.

### Параметры ###

Параметры компонента описаны в таблице. Стандартные параметры для компонента опущены, о них можно узнать в документации Битрикс.

| Параметр | Описание                    |
| ------------- | ------------------------------ |
| SAVE_IN      | Место хранения результатов выбора сортировки С - cookie, S - сессия.  |
| COOKIE_EXPIRES      | Время жизни cookie файлов в днях.  |
| SUFFIX   |  Суффикс имени переменной cookie или сессии. Содержит произвольный набор латинских букв и цифр. Используется для создания уникального имени, которое не будет пересекаться с другими сайтами и экземплярами компонента.    |
| ELEMENT_SORT_FIELD      | Поле первичной сортировки по умолчанию.  |
| ELEMENT_SORT_ORDER      | Направление первичной сортировки по умолчанию.  |
| SORTING      | Пункты сортировки. JSON строка содержащая информацию о названиях, полях и направлении сортировки каждого доступного пункта  |

Пункты сортировки могут быть следующих типов:

Пользовательский(CUSTOM) - мажет проводить сортировку по любому полю в любом направлении. Указываются вручную (поля FIELD и DIR).

Предустановленные:
* По умолчанию (индексу сортировки) (DEFAULT) - по убыванию
* По популярности (количество показов) (POPULARITY) - по убыванию
* По дате (начало активности) (DATE) - по убыванию
* Название по возрастанию (NAME_ASC)
* Название по убыванию (NAME_DESC)
* Цена по возрастанию (PRICE_ASC) - корректно работает не при всех настройках каталога и интернет-магазина.
* Цена по убыванию (PRICE_DESC) - корректно работает не при всех настройках каталога и интернет-магазина.

Для этих типов поля и направления установить вручную нельзя.
